CVE-2023-30861

NameCVE-2023-30861
DescriptionFlask is a lightweight WSGI web application framework. When all of the following conditions are met, a response containing data intended for one client may be cached and subsequently sent by the proxy to other clients. If the proxy also caches `Set-Cookie` headers, it may send one client's `session` cookie to other clients. The severity depends on the application's use of the session and the proxy's behavior regarding cookies. The risk depends on all these conditions being met. 1. The application must be hosted behind a caching proxy that does not strip cookies or ignore responses with cookies. 2. The application sets `session.permanent = True` 3. The application does not access or modify the session at any point during a request. 4. `SESSION_REFRESH_EACH_REQUEST` enabled (the default). 5. The application does not set a `Cache-Control` header to indicate that a page is private or should not be cached. This happens because vulnerable versions of Flask only set the `Vary: Cookie` header when the session is accessed or modified, not when it is refreshed (re-sent to update the expiration) without being accessed or modified. This issue has been fixed in versions 2.3.2 and 2.2.5.
SourceCVE (at NVD; CERT, LWN, oss-sec, fulldisc, Red Hat, Ubuntu, Gentoo, SUSE bugzilla/CVE, GitHub advisories/code/issues, web search, more)
ReferencesDLA-3536-1, DSA-5442-1
Debian Bugs1035670

Vulnerable and fixed packages

The table below lists information on source packages.

Source PackageReleaseVersionStatus
flask (PTS)buster1.0.2-3vulnerable
buster (security)1.0.2-3+deb10u1fixed
bullseye (security), bullseye1.1.2-2+deb11u1fixed
bookworm2.2.2-3fixed
trixie, sid3.0.2-1fixed

The information below is based on the following data on fixed versions.

PackageTypeReleaseFixed VersionUrgencyOriginDebian Bugs
flasksourcebuster1.0.2-3+deb10u1DLA-3536-1
flasksourcebullseye1.1.2-2+deb11u1DSA-5442-1
flasksource(unstable)2.2.2-31035670

Notes

https://github.com/pallets/flask/security/advisories/GHSA-m2qf-hxjv-5gpq
https://github.com/pallets/flask/commit/8646edca6f47e2cd57464081b3911218d4734f8d (2.2.5)
https://github.com/pallets/flask/commit/8705dd39c4fa563ea0fe0bf84c85da8fcc98b88d (2.3.2)

Search for package or bug name: Reporting problems